package com.tony.firebasetest

import android.content.Context
import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Surface
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.tooling.preview.Preview
import com.google.firebase.FirebaseApp
import com.google.firebase.FirebaseOptions
import com.google.firebase.analytics.FirebaseAnalytics
import com.google.firebase.crashlytics.FirebaseCrashlytics
import com.google.firebase.perf.FirebasePerformance
import com.tony.firebasetest.ui.theme.FirebaseTestTheme
import java.net.URL

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            FirebaseTestTheme {
                // A surface container using the 'background' color from the theme
                Surface(
                    modifier = Modifier.fillMaxSize(),
                    color = MaterialTheme.colorScheme.background
                ) {
                    Greeting("Android")
                }
            }
        }
        val url = URL("https", "www.amazon.com", 443, "")
        val inputStream = url.openStream()
    }
}

@Composable
fun Greeting(name: String, modifier: Modifier = Modifier) {
    Text(
        text = "Hello $name!",
        modifier = modifier.clickable {
            // click to init firebase sdk (similar to user accept privacy policy terms)
            // enableFirebaseCollection()
        }
    )
}

@Preview(showBackground = true)
@Composable
fun GreetingPreview() {
    FirebaseTestTheme {
        Greeting("Android")
    }
}

private fun enableFirebaseCollection(context: Context) {
    val builder = FirebaseOptions.Builder()
        .setApplicationId("")
        .setApiKey("")
        .setProjectId("")
        .setStorageBucket("")
    FirebaseApp.initializeApp(context, builder.build())

    FirebaseCrashlytics.getInstance().setCrashlyticsCollectionEnabled(true)
    FirebaseAnalytics.getInstance(context).setAnalyticsCollectionEnabled(true)
    FirebasePerformance.getInstance().isPerformanceCollectionEnabled = true
}